<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Projectile.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Projectile.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Projectile_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Projectile_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Projectile_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="GameObject_8h.html">GameObject.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;utility&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>;</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classProjectile.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="classProjectile.html">Projectile</a> : <span class="keyword">public</span> <a class="code" href="classGameObject.html">GameObject</a>{</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="classProjectile.html#a29f8169d5b3e6df60de4b5c7d015ae02">Projectile</a>(<span class="keywordtype">int</span> x , <span class="keywordtype">int</span> y , <span class="keywordtype">int</span> vectX, <span class="keywordtype">int</span> vectY);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classProjectile.html#a42c3fc33d84481ac3e7b46eaa3990719">Update</a>();</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classProjectile.html#a9f2eea984180f9b5d9d6a4da97bbff33">Visit</a> (<a class="code" href="classCollisionVisitor.html">CollisionVisitor</a> * visitor) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classProjectile.html#ae28e683bcb0193b6ec33defda53caed7">CollideWith</a> (<a class="code" href="classGameObject.html">GameObject</a> * collisionObject) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classProjectile.html#a8f51d1cc762b462b94c280fff8ea7a7f">GetDmg</a>()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classProjectile.html#a3a9b60c10bc1f9e423a59c552fdfdc03">   29</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classProjectile.html#a3a9b60c10bc1f9e423a59c552fdfdc03">m_Damage</a>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;};</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classRocket.html">   36</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRocket.html">Rocket</a> : <span class="keyword">public</span> <a class="code" href="classProjectile.html">Projectile</a>{</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classRocket.html#a8dd93360cf2d88756ac54d690e90f619">Rocket</a>(<span class="keywordtype">int</span> x , <span class="keywordtype">int</span> y , <span class="keywordtype">int</span> vectX, <span class="keywordtype">int</span> vectY);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classMiniRocket.html">   53</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMiniRocket.html">MiniRocket</a> : <span class="keyword">public</span> <a class="code" href="classProjectile.html">Projectile</a> {</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="classMiniRocket.html#a36c0c4f8ba6b0a5108cf37492bad4e83">MiniRocket</a>(<span class="keywordtype">int</span> x , <span class="keywordtype">int</span> y , <span class="keywordtype">int</span> vectX, <span class="keywordtype">int</span> vectY);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;};</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classShell.html">   70</a></span>&#160;<span class="keyword">class </span><a class="code" href="classShell.html">Shell</a> : <span class="keyword">public</span> <a class="code" href="classProjectile.html">Projectile</a>{</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="classShell.html#a73240e4ed07f76235774bb3a0a545498">Shell</a>(<span class="keywordtype">int</span> x , <span class="keywordtype">int</span> y , <span class="keywordtype">int</span> vectX, <span class="keywordtype">int</span> vectY);</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;};</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classBullet.html">   87</a></span>&#160;<span class="keyword">class </span><a class="code" href="classBullet.html">Bullet</a> : <span class="keyword">public</span> <a class="code" href="classProjectile.html">Projectile</a>{</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classBullet.html#a0fafff39183a018fed0233049d3aa0ca">Bullet</a>(<span class="keywordtype">int</span> x , <span class="keywordtype">int</span> y , <span class="keywordtype">int</span> vectX, <span class="keywordtype">int</span> vectY);</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBullet.html#aaa6813fa215431eea252ca9adfd99a48">OnBorderCollision</a>() <span class="keyword">override</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;};</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Projectile_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassBullet_html_a0fafff39183a018fed0233049d3aa0ca"><div class="ttname"><a href="classBullet.html#a0fafff39183a018fed0233049d3aa0ca">Bullet::Bullet</a></div><div class="ttdeci">Bullet(int x, int y, int vectX, int vectY)</div><div class="ttdoc">Construct a new Bullet object with given coordinates and movement vector.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:57</div></div>
<div class="ttc" id="aclassBullet_html"><div class="ttname"><a href="classBullet.html">Bullet</a></div><div class="ttdoc">Bullet projectile with ability to bounce off borders.</div><div class="ttdef"><b>Definition:</b> Projectile.h:87</div></div>
<div class="ttc" id="aclassProjectile_html_a42c3fc33d84481ac3e7b46eaa3990719"><div class="ttname"><a href="classProjectile.html#a42c3fc33d84481ac3e7b46eaa3990719">Projectile::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdoc">Pure virtual Update function that is used in GameScene's game loop.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:14</div></div>
<div class="ttc" id="aclassMiniRocket_html_a36c0c4f8ba6b0a5108cf37492bad4e83"><div class="ttname"><a href="classMiniRocket.html#a36c0c4f8ba6b0a5108cf37492bad4e83">MiniRocket::MiniRocket</a></div><div class="ttdeci">MiniRocket(int x, int y, int vectX, int vectY)</div><div class="ttdoc">Construct a new Mini Rocket object with given coordinates and movement vector.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:42</div></div>
<div class="ttc" id="aclassShell_html"><div class="ttname"><a href="classShell.html">Shell</a></div><div class="ttdoc">Cannon projectile fast and hard hitting.</div><div class="ttdef"><b>Definition:</b> Projectile.h:70</div></div>
<div class="ttc" id="aclassRocket_html_a8dd93360cf2d88756ac54d690e90f619"><div class="ttname"><a href="classRocket.html#a8dd93360cf2d88756ac54d690e90f619">Rocket::Rocket</a></div><div class="ttdeci">Rocket(int x, int y, int vectX, int vectY)</div><div class="ttdoc">Construct a new Rocket object with given coordinates and movement vector.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:30</div></div>
<div class="ttc" id="aclassBullet_html_aaa6813fa215431eea252ca9adfd99a48"><div class="ttname"><a href="classBullet.html#aaa6813fa215431eea252ca9adfd99a48">Bullet::OnBorderCollision</a></div><div class="ttdeci">void OnBorderCollision() override</div><div class="ttdoc">Makes bullets bounce off borders.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:63</div></div>
<div class="ttc" id="aclassProjectile_html_a9f2eea984180f9b5d9d6a4da97bbff33"><div class="ttname"><a href="classProjectile.html#a9f2eea984180f9b5d9d6a4da97bbff33">Projectile::Visit</a></div><div class="ttdeci">void Visit(CollisionVisitor *visitor) override</div><div class="ttdoc">Pure virtual function for accepting visitor.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:22</div></div>
<div class="ttc" id="aclassProjectile_html"><div class="ttname"><a href="classProjectile.html">Projectile</a></div><div class="ttdoc">class representing projectiles with their own speed, damage and sprites</div><div class="ttdef"><b>Definition:</b> Projectile.h:12</div></div>
<div class="ttc" id="aclassProjectile_html_a3a9b60c10bc1f9e423a59c552fdfdc03"><div class="ttname"><a href="classProjectile.html#a3a9b60c10bc1f9e423a59c552fdfdc03">Projectile::m_Damage</a></div><div class="ttdeci">int m_Damage</div><div class="ttdef"><b>Definition:</b> Projectile.h:29</div></div>
<div class="ttc" id="aclassProjectile_html_ae28e683bcb0193b6ec33defda53caed7"><div class="ttname"><a href="classProjectile.html#ae28e683bcb0193b6ec33defda53caed7">Projectile::CollideWith</a></div><div class="ttdeci">void CollideWith(GameObject *collisionObject) override</div><div class="ttdoc">Creates Visitor object and passes collisionObject parameter.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:25</div></div>
<div class="ttc" id="aclassShell_html_a73240e4ed07f76235774bb3a0a545498"><div class="ttname"><a href="classShell.html#a73240e4ed07f76235774bb3a0a545498">Shell::Shell</a></div><div class="ttdeci">Shell(int x, int y, int vectX, int vectY)</div><div class="ttdoc">Construct a new Shell object with given coordinates and movement vector.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:49</div></div>
<div class="ttc" id="aclassProjectile_html_a29f8169d5b3e6df60de4b5c7d015ae02"><div class="ttname"><a href="classProjectile.html#a29f8169d5b3e6df60de4b5c7d015ae02">Projectile::Projectile</a></div><div class="ttdeci">Projectile(int x, int y, int vectX, int vectY)</div><div class="ttdoc">Construct a new Projectile object with given coordinates and movement vector.</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:5</div></div>
<div class="ttc" id="aclassRocket_html"><div class="ttname"><a href="classRocket.html">Rocket</a></div><div class="ttdoc">Rocket projectile balanced big projectile.</div><div class="ttdef"><b>Definition:</b> Projectile.h:36</div></div>
<div class="ttc" id="aclassMiniRocket_html"><div class="ttname"><a href="classMiniRocket.html">MiniRocket</a></div><div class="ttdoc">MiniRocket mini projectile supplementing Rocket projectile.</div><div class="ttdef"><b>Definition:</b> Projectile.h:53</div></div>
<div class="ttc" id="aclassProjectile_html_a8f51d1cc762b462b94c280fff8ea7a7f"><div class="ttname"><a href="classProjectile.html#a8f51d1cc762b462b94c280fff8ea7a7f">Projectile::GetDmg</a></div><div class="ttdeci">int GetDmg() const</div><div class="ttdef"><b>Definition:</b> Projectile.cpp:18</div></div>
<div class="ttc" id="aGameObject_8h_html"><div class="ttname"><a href="GameObject_8h.html">GameObject.h</a></div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
